#! /usr/local/bin/python

#Universidad Nacional Autonoma de Mexico
#PAPIME PE 400216
#DGAPA
#Programacion y diseno: Hadassa Amelia Juarez Hernandez. 2016 Attributions in /attributions
#Uncommented version

import os
import pygame
from pygame.locals import *
from pygame.color import THECOLORS
from word import Word
import random
import sys
from marks import Mark

EXEC_DIR = os.path.dirname(__file__)  

if sys.platform == 'darwin':
    image_dir = os.walk("word_files")
else:
    image_dir = os.walk(os.path.join(EXEC_DIR, "word_files"))

pygame.init()

screen = pygame.display.set_mode((800, 650))

idioma = 1
colorElse = [255,255,255]

if idioma == 1:
    fondo = pygame.image.load('Images/German.jpg').convert()

Bfondo = pygame.transform.smoothscale(fondo, (800,650))

pygame.display.set_caption("Illustrations French Chapter 2 Papime PE 400216 UNAM")

blanco = pygame.image.load("Images/blanco.jpg").convert_alpha()
Sblanco = pygame.transform.smoothscale(blanco, (120, 50))

colorLetras = 255

Titulo = os.path.join("fonts","Titulos.TTF")
subtitulos = os.path.join("fonts","subtitulos.TTF")

global the_word
global entered_text
global ignored_keys
global wrong
global right
global hyphen

font = pygame.font.SysFont('Helvetica', 37)
font2 = pygame.font.SysFont('Helvetica', 22)

color = colorElse

clock = pygame.time.Clock()
image_list = []
right = False
wrong = False
entered_text = []
screen_x, screen_y = screen.get_size()

for root, dir, files in image_dir:
    for file in files:
        if '.DS_Store' not in file:
            image_list.append(file)

the_word = Word(random.choice(image_list))

ignored_keys = ('escape', 'return', 'backspace',"space", 'enter', 'right shift'\
                ,'left shift', 'left meta', 'right meta', 'f1', 'f2', 'f3', 'f4', 'f5'\
                ,'f6', 'f7', 'f8', 'f9', 'f10', 'f11', 'f12', 'f13', 'f14', 'f15', 'caps lock')

happy = Mark('correcto')

sad = Mark('incorrecto')

happy_group = pygame.sprite.GroupSingle()

sad_group = pygame.sprite.GroupSingle()
hyphen = False

pygame.key.set_repeat(0,0)

points=0

while 1:
    cursor=0
    letter_position = dict()
    key = pygame.key.get_pressed()
    mods = pygame.key.get_mods()
        
    screen.blit(Bfondo, (0, 0))
            
    msg_p1 = font2.render('Puntaje',1,(0,0,0))
    msg_p1p = font2.render(str(points),1,(0,0,0))
            
    screen.blit(Sblanco, (0, 270))
    screen.blit(msg_p1,(20,270))
    screen.blit(msg_p1p,(60,295))

    the_word.draw(screen, (screen_x/2 - the_word.width/2), 80)
    
    num_lines = len(the_word.letters)
    underline_width = 12
    text_total_width = (num_lines * underline_width) + ((num_lines - 1) * 20)
    line_x1 = screen_x/2 - text_total_width/2
        
    letter_beginning_list = []
    
    letter_beginning = screen_x/2 - text_total_width/2
        
    letter_keys = range(0, the_word.length)
        
    for letter in the_word.letters:
        letter_size = font.size(letter)
        letter_beginning_list.append([letter_beginning + (underline_width/2 - letter_size[0]/2), letter])
        correct_letter = font.render(letter, 1, (0, 0, 0))
        letter_size = font.size(letter)

        letter_beginning += underline_width + 20
            
           
        line_x2 = line_x1 + underline_width
        pygame.draw.line(screen, THECOLORS['white'], (line_x1, 460), (line_x2, 460), 2)
        line_x1 += underline_width + 20
        line_x2 += underline_width + 20
        
    letter_dict = dict(zip(letter_keys, letter_beginning_list))

    if sad.lifespan == 0:
        sad_group.empty()
        wrong = False
        correct=1
    sad_group.update()

    if happy.lifespan == 0:
        happy_group.empty()
        right = False
        correct=0
        the_word = Word(random.choice(image_list))
        happy.reset()
    happy_group.update()

    if right:
        clock.tick(13)
        happy_group.draw(screen)
        entered_text = []

    if wrong:
        clock.tick(13)
        sad_group.draw(screen)
        entered_text = []

    if key[pygame.K_ESCAPE]:
        sys.exit()
            
    if hyphen:
        entered_text.append('-')
        hyphen = False

    for event in pygame.event.get():

        if event.type == pygame.QUIT:
                        sys.exit()
            
        if event.type == pygame.KEYDOWN:
            key_value = pygame.key.name(event.key)
            if key_value == 'backspace':
                if entered_text:
                    entered_text.pop()
    
            if key_value not in ignored_keys:
                entered_text.append(key_value)
                
            if key_value == 'return':
                hyphen_pos = [i for i,x in enumerate(the_word.letters) if x == '-']
                print(hyphen_pos)
                if hyphen_pos:
                    del(the_word.letters[int(hyphen_pos[0])])
                    
                if entered_text == the_word.letters:
                    happy_group.add(happy)
                    right = True
                    points=points+1

                else:
                    sad.reset()
                    sad_group.add(sad)
                    wrong = True

    for letter in entered_text:
        if not letter == 'backspace':
            if letter_dict.get(cursor)[1] == '-':
                cursor += 1
            
            correct_letter = font.render(letter, 1, (colorLetras, colorLetras, colorLetras))
            letter_size = font.size(letter)
            screen.blit(correct_letter, [letter_dict.get(cursor)[0], 410])
            cursor += 1

    """
    if points == 20:
        break
    """
            
    pygame.display.update()
    #clock.tick(15)
       
pygame.display.flip()
#pygame.time.delay(20)

quit()
